.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include wsock32.inc
includelib wsock32.lib

;***************************************************************************************************

.const
hostIP      db "69.147.114.224",0   ;"yahoo.com"
wPort       dw 80

AppName     db "WinSock Test",0
errWSAStart db "WSAStartup failed! (error-code %d)",0
errSocket   db "socket failed! (error-code %d)",0
errConnect  db "connect failed! (error-code %d)",0
okConnect   db "Connected!",0

.data? 
wsadata     WSADATA <?>
hSock       SOCKET ?
sin         sockaddr_in <?>

.code
errBox proc pErrMsg:DWORD
    LOCAL buff[256]:BYTE
    invoke WSAGetLastError
    invoke wsprintf, ADDR buff,pErrMsg,eax
    invoke MessageBox, NULL,ADDR buff,ADDR AppName,MB_OK or MB_ICONERROR
    ret
errBox endp

start:
    invoke WSAStartup, 202h,ADDR wsadata
    .IF (!eax)
        invoke socket, AF_INET,SOCK_STREAM,IPPROTO_TCP
        .IF (eax != INVALID_SOCKET)
            mov hSock,eax

            invoke inet_addr, ADDR hostIP
            mov sin.sin_addr,eax
            movzx eax,wPort
            invoke htons, eax
            mov sin.sin_port,ax
            mov sin.sin_family,AF_INET
            invoke connect, hSock,ADDR sin,SIZEOF sin
            .IF (eax != SOCKET_ERROR)
                invoke MessageBox, NULL,ADDR okConnect,ADDR AppName,MB_OK or MB_ICONINFORMATION

                ;....send, recv, etc....

                invoke closesocket, hSock
            .ELSE
                invoke errBox, ADDR errConnect
            .ENDIF
        .ELSE
            invoke errBox, ADDR errSocket
        .ENDIF
        invoke WSACleanup
    .ELSE
        invoke errBox, ADDR errWSAStart
    .ENDIF
    invoke ExitProcess, NULL
end start
